package helloagain.kanday;

import java.util.logging.Logger;


/**
 * KandayMain.java
 *
 * HelloAgain Desktop҃vOmain񋟂NXB
 * v@\́A
 * <ul>
 * <li>vOÑXvbVʕ\
 * <li>KandayPrefereces̐
 * <li>KandayFrame̐
 * <li>Vbg_EtbNŏIOɐݒ̕ۑ
 * </ul>
 * <p>
 * R}hC
 * <ul>
 * <li>-nologo XvbV\Ȃ
 * <li>-notoolbar c[o[\Ȃ()
 * </ul>
 * <p>
 * Created: Wed May 26 12:54:18 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 */

public class KandayMain{

    /**
     * vONɌĂ΂<code>main</code>\bhB
     * @param args R}hC
     */
    public static final void main(final String[] args) {
        logger.entering(MYCLASS, "main", args);
        startTime = System.currentTimeMillis();

        for (int i=0; i<args.length; i++) {
            if ("-nologo".equals(args[i])) {
                // XvbVʕ\}ݒ
                isSplash = false;
            } else if ("-notoolbar".equals(args[i])) {
                // no implement
            }
        }

        // XvbVʕ\
        showSplash();

        final KandayPreferences pref = new KandayPreferences();
        final KandayFrame frame = new KandayFrame(pref);
        
        // Vbg_EtbN̒ǉ
        Runtime.getRuntime().addShutdownHook(new Thread() {
                public void run() {
                    savePreferences(pref, frame);
                }
            });

        // XvbV\Ԃ̒
        waitSplash();

        frame.setVisible(true);
        logger.exiting(MYCLASS, "main");
    }

    /**
     * sRs[^̉ʒɈʒuXvbVʂ
     * BNXϐ<code>isSplash</code>Uł΁A
     * ^[B
     */
    private static void showSplash() {
        logger.entering(MYCLASS, "showSplash");
        if (isSplash == false) {
            logger.config("Splash is disabled");
            return;
        }

        splash = new KandaySplash();
        splash.setVisible(true);
        logger.exiting(MYCLASS, "showSplash");
    }

    /**
     * \ĂXvbVʂ^C~O}A
     * XvbVʂjB
     * 萔SPLASH_DURATION_TIME~b̌o߂҂BAvO
     * NĂ{\bhĂ΂܂łɌo߂Ԃ
     * B
     */
    private static void waitSplash() {
        logger.entering(MYCLASS, "waitSplash");
        if (isSplash == false) {
            return;
        }
        long lapse = System.currentTimeMillis() - startTime;
        if (lapse < SPLASH_DURATION_TIME ) {
            try {
                Thread.sleep(SPLASH_DURATION_TIME - lapse);
            } catch (InterruptedException e) {
                // do nothing
            }
        }
        splash.setVisible(false);
        logger.exiting(MYCLASS, "waitSplash");
    }

    /**
     * iΏۃf[^ۑ鏈ĂяoB
     * @param aPreferences ȉsCX^X
     * @param aFrame iΏۃf[^̎擾ɕKv
     */
    private static void savePreferences(
        KandayPreferences aPreferences, KandayFrame aFrame
    ) {
        logger.entering(MYCLASS, "savePreferences",
                        new Object[] {aPreferences, aFrame}
        );
        int positionX = aFrame.getLocation().x;
        int positionY = aFrame.getLocation().y;
        int width = aFrame.getWidth();
        int height = aFrame.getHeight();

        aPreferences.setFramePositionX(positionX);
        aPreferences.setFramePositionY(positionY);
        aPreferences.setFrameWidth(width);
        aPreferences.setFrameHeight(height);
        aPreferences.save();

        logger.exiting(MYCLASS, "savePreferences");
    }

    /** XvbVʂ\鎞[ms] */
    private final static int SPLASH_DURATION_TIME = 5000;
    /** XvbVʂ̕\LtO */
    private static boolean isSplash = true;
    /** XvbVʃCX^X */
    private static KandaySplash splash;
    /** XvbVʕ\JnԂێ */
    private static long startTime;

    // MO֘A
    private static final String MYCLASS = KandayMain.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);
} // KandayMain
