package helloagain.kanday;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * vO\_CAOB
 * vÕC[WƁAȒPȐARs[Cg\A
 * vÕo[W\sB
 * <p>
 * Created: Wed Jun 02 18:36:17 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 */
public class KandayAboutDialog extends JDialog {

    /**
     * vO\_CAO𐶐B
     * @param anOwner ̃_CAO̐eƂȂt[
     * @param aTitle _CAÕ^Cgo[ɕ\镶
     * @param anIcon _CAỎ摜
     * @param aDescription vO̐
     * @param aVersion vÕo[Wʎq
     * @param aCopyright vO̒쌠\L
     */
    public KandayAboutDialog(
        Frame anOwner, String aTitle, Icon anIcon, String aDescription,
        String aVersion, String aCopyright
    ) {
        super(anOwner, aTitle, true);
        if (logger.isLoggable(Level.FINER)) {
            logger.entering(
                MYCLASS, "KandayAboutDialog",
                new Object[] {anOwner, aTitle, anIcon, aDescription,
                              aVersion, aCopyright }
            );
        }
        getContentPane().setBackground(Color.WHITE);
        JLabel imageLabel = new JLabel(anIcon);
        getContentPane().add(imageLabel, BorderLayout.NORTH);
        String message = "<html><center>" + aDescription + "<br>Version : " +
            aVersion + "<br>" + aCopyright + "</center></html>";
        JLabel messageLabel = new JLabel(message, JLabel.CENTER);
        getContentPane().add(messageLabel, BorderLayout.CENTER);

        final JButton okButton = new JButton("OK");
        okButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent ev) {
                    dispose();
                }
            });
        JPanel panel = new JPanel();
        panel.setBackground(Color.WHITE);
        panel.add(okButton);
        getContentPane().add(panel, BorderLayout.SOUTH);

        // _CAO\ꂽɁA[OK]{^ɃtH[JXݒ
        addWindowListener(new WindowAdapter() {
                public void windowOpened(WindowEvent ev) {
                    okButton.requestFocus();
                }
            });

        pack();
        setResizable(false);
        setLocationRelativeTo(anOwner);
            logger.exiting(MYCLASS, "KandayAboutDialog");
    }
    private static final String MYCLASS = KandayAboutDialog.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);
}
