package helloagain.kanday;

import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.Action;
import java.util.logging.Logger;

/**
 * AvP[VEEBhẼj[o[\NXB
 * ȉ̃j[\B
 * <ul>
 *  <li>File
 *   <ul>
 *    <li>Preferences
 *    <li>Exit
 *   </ul>
 *  <li>Help
 *   <ul>
 *    <li>About
 *   </ul>
 * </ul>
 * <p>
 * Created: Wed May 26 12:03:48 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 */
public class KandayMenuBar extends JMenuBar {

    /**
     * ɃvOݒ<code>KandayPreferences</code>
     * CX^XRXgN^B
     *
     * ej[ڂ́̕A̐ݒ񂩂擾B
     * @param aPreferences vOݒ
     */
    public KandayMenuBar(KandayPreferences aPreferences) {
        logger.entering(MYCLASS, "KandayMenuBar", aPreferences);
        fileMenu = new JMenu(aPreferences.getMenuFile());
        fileMenu.setMnemonic('F');
        add(fileMenu);
        preferencesItem = new JMenuItem(aPreferences.getMenuPreferences());
        fileMenu.add(preferencesItem);
        exitItem = new JMenuItem(aPreferences.getMenuExit());
        fileMenu.add(exitItem);

        helpMenu = new JMenu(aPreferences.getMenuHelp());
        helpMenu.setMnemonic('H');
        add(helpMenu);
        aboutItem = new JMenuItem(aPreferences.getMenuAbout());
        helpMenu.add(aboutItem);
        logger.exiting(MYCLASS, "KandayMenuBar");
    }

    /**
     * File - Preferencesj[IƂɎsANV
     * ݒB
     * @param anAction File->Preferences ANV
     */
    public void setPreferencesAction(Action anAction) {
        logger.entering(MYCLASS, "setPreferencesAction", anAction);
        preferencesItem.setAction(anAction);
        logger.exiting(MYCLASS, "setPreferencesAction");
    }

    /**
     * File - Exitj[IƂɎsANVݒB
     * @param anAction File->Exit ANV
     */
    public void setExitAction(Action anAction) {
        logger.entering(MYCLASS, "setExitAction", anAction);
        exitItem.setAction(anAction);
        logger.exiting(MYCLASS, "setExitAction");
    }

    /**
     * Help - Aboutj[IƂɎsANVݒB
     * @param anAction Help->About ANV
     */
    public void setAboutAction(Action anAction) {
        logger.entering(MYCLASS, "setAboutAction", anAction);
        aboutItem.setAction(anAction);
        logger.exiting(MYCLASS, "setAboutAction");
    }

    private JMenu fileMenu;
    private JMenuItem preferencesItem;
    private JMenuItem exitItem;
    private JMenu helpMenu;
    private JMenuItem aboutItem;

    private static final String MYCLASS = KandayMenuBar.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);
}
