package helloagain.kanday;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JComponent;

/**
 * bZ[W\paneB
 * ^ꂽ傫ɑ΂Ē1s̕\B
 *
 * <p>
 * Created: Wed May 26 12:04:57 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 */
public class KandayPane extends JComponent {

    /**
     * RXgN^B
     * tHgŒŐBSerif, 18point
     */
    public KandayPane() {
        font = new Font("Serif", Font.PLAIN, 18);
        setOpaque(true);
    }

    /**
     * `悷郁bZ[Wݒ肷B
     * bZ[Wݒ莞ɁA`悵ۂ̑悻̕vZĂB
     * @param aMessage `悷镶
     */
    public void setMessage(String aMessage) {
        message = aMessage;
        updateMessageWidth();
    }

    /**
     * tHgݒ肷B
     * @param aFont tHg
     */
    public void setFont(Font aFont) {
        font = aFont;
        updateMessageWidth();
    }

    /**
     * R|[lg`掞ɁAmessage\B
     * `ʒúAR|lĝɈʒu悤ZoB
     *
     * @param graphics a <code>Graphics</code> value
     */
    public final void paintComponent(final Graphics graphics) {
        if (logger.isLoggable(Level.FINER)) {
            logger.entering("MYCLASS", "paintComponent", graphics);
            logger.finer("background color = " + getBackground());
            logger.finer("foreground color = " + getForeground());
        }
        super.paintComponent(graphics);
        graphics.setColor(getBackground());
        graphics.fillRect(0, 0, getWidth(), getHeight());

        int x = (getWidth() / 2) - (messageWidth / 2);
        int y = (getHeight() / 2);
        graphics.setFont(font);
        graphics.setColor(getForeground());
        graphics.drawString(message, x, y);
    }

    private void updateMessageWidth() {
        FontMetrics metrics = getFontMetrics(font);
        messageWidth = metrics.stringWidth(message);
    }

    private String message;
    private Font font;
    private int messageWidth;

    private static final String MYCLASS = KandayPane.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);
}
