package helloagain.kanday;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

/**
 * vO̐ݒύX_CAOB
 * bZ[W\y[̑OiFAwiFύXB
 * CAEgɂ́A<code>SpringLayout</code>gpB
 * <pre>
 * ʃfUCTv
 * +--------------------------------+
 * |Preferences                     |  <-- ^Cg
 * +--------------------------------+
 * |Foreground Color:   [Change]  |  <-- JLabel + JTextField + JButton
 * |Background Color:   [Change]  |  <-- 
 * |                                |
 * |           [Apply]  [Cancel]    |  <-- JButton + JButton
 * +--------------------------------+
 * </pre>
 * OiFƔwiF݂̌̐F\̂ɁAJTextFieldgpA
 * backgroundɐݒ肵ĎĂB
 * \镶́A<code>KandayPreferences</code>擾ĂB
 * <pre>
 * zuʒu̐ݒ(SpringLayout)
 * +------------------------------------------+
 * |_CAÕ^Cg                    |
 * +------------------------------------------+
 * | 1     |2     3     |4       5     |6     |
 * |<->[ JLabel ]<->[JTextField]<->[JButton]  |
 * |            ^^^^^^^^|^^^^^^^^^^^^^^|      |
 * | 7     |8   : 9     |10      11    |12    |
 * |<->[JLabel] :<->[JTextField]<->[JButton]  |
 * |          :                               |
 * |          :13         14                  |
 * |          :<->[Apply]<->[Cancel]          |
 * |                 |15       |16            |
 * +------------------------------------------+
 * [ 1]  10 pixel    [ 6]  25 pixel    [11]  10 pixel    [16] -10 pixel
 * [ 2]  25 pixel    [ 7]  10 pixel    [12]  20 pixel
 * [ 3]  10 pixel    [ 8]  20 pixel    [13]  10 pixel
 * [ 4]  25 pixel    [ 9]  10 pixel    [14]  25 pixel
 * [ 5]  10 pixel    [10]  20 pixel    [15] -10 pixel
 * </pre>
 * <ul>
 * <li>[9]́AׂJLabelł͂ȂA̍sJLabelƂ̊ԊuŎw肵ĂB
 * <li>[10][12]́AJLabelƂ̊ԊuŎw肵ĂB
 * <li>[15][16]́AԊu̒lƂȂĂBcontentPaneSOUTH
 * Ɉʒu邽߂łB
 * </ul>
 * <p>
 * Created: Thu Jun 10 05:45:53 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 * @see javax.swing.SpringLayout
 */
public class KandayPreferencesDialog extends JDialog {

    /**
     * vO̐ݒύX_CAO𐶐B
     * @param anOwner ̃_CAO̐eƂȂt[
     * @param aPreferences ݒێCX^X
     */
    public KandayPreferencesDialog(
        final Frame anOwner, final KandayPreferences aPreferences
    ) {
        super(anOwner, aPreferences.getPreferencesDialogTitle(), true);
        if (logger.isLoggable(Level.FINER)) {
            logger.entering(
                MYCLASS, "KandayPreferencesDialog",
                new Object[] {anOwner, aPreferences}
            );
        }
        foregroundColor = aPreferences.getMessageForegroundColor();
        backgroundColor = aPreferences.getMessageBackgroundColor();
        SpringLayout layout = new SpringLayout();
        Container contentPane = getContentPane();
        contentPane.setLayout(layout);

        // Foreground Colorx̐
        JLabel foregroundLabel = new JLabel(
            aPreferences.getPreferencesDialogFglabelText()
        );
        // OiF\tB[h̐
        final JTextField foregroundField = new JTextField(8);
        foregroundField.setEditable(false);
        foregroundField.setBackground(foregroundColor);
        // OiFύX{^̐
        JButton foregroundChangeButton = new JButton(
            aPreferences.getPreferencesDialogChangebuttonText()
        );
        // JLabel/JTextField̍JButton̍ftHgł͕sލ
        // ̂߁AJButton̍JTextField̍ɑ
        foregroundChangeButton.setPreferredSize(
            new Dimension(foregroundChangeButton.getPreferredSize().width,
                          foregroundField.getPreferredSize().height)
        );
        // ύX{^ꂽAFI_CAON
        foregroundChangeButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent ev) {
                    Color newColor = JColorChooser.showDialog(
                        KandayPreferencesDialog.this,
                        aPreferences.getPreferencesDialogFgcolorchooserTitle(),
                        foregroundColor
                    );
                    if (newColor != null) {
                        foregroundColor = newColor;
                        foregroundField.setBackground(foregroundColor);
                    }
                }
            }
        );

        // Background Colorx̐
        JLabel backgroundLabel = new JLabel(
            aPreferences.getPreferencesDialogBglabelText()
        );
        // wiF\tB[h̐
        final JTextField backgroundField = new JTextField(8);
        backgroundField.setEditable(false);
        backgroundField.setBackground(backgroundColor);
        // wiFύX{^̐
        JButton backgroundChangeButton = new JButton(
            aPreferences.getPreferencesDialogChangebuttonText()
        );
        backgroundChangeButton.setPreferredSize(
            new Dimension(backgroundChangeButton.getPreferredSize().width,
                          backgroundField.getPreferredSize().height)
        );
        backgroundChangeButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent ev) {
                    Color newColor = JColorChooser.showDialog(
                        KandayPreferencesDialog.this,
                        aPreferences.getPreferencesDialogBgcolorchooserTitle(),
                        backgroundColor
                    );
                    if (newColor != null) {
                        backgroundColor = newColor;
                        backgroundField.setBackground(backgroundColor);
                    }
                }
            }
        );

        // Apply{^̐
        JButton applyButton = new JButton(
            aPreferences.getPreferencesDialogApplybuttonText()
        );
        // Apply{^ꂽAKandayPreferencesύX
        // KandayFrameɕύXʒmĂ_CAOj
        applyButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent ev) {
                    boolean viewUpdate = false;
                    if (!aPreferences.getMessageForegroundColor().equals(
                            foregroundColor)
                    ) {
                        aPreferences.setMessageForegroundColor(foregroundColor);
                        viewUpdate = true;
                        logger.finer("apply fgcolor=" + foregroundColor);
                    }
                    if (!aPreferences.getMessageBackgroundColor().equals(
                            backgroundColor)
                    ) {
                        aPreferences.setMessageBackgroundColor(backgroundColor);
                        viewUpdate =true;
                        logger.finer("apply bgcolor=" + backgroundColor);
                    }
                    if (viewUpdate == true) {
                        ((KandayFrame)anOwner).updatePreferences();
                    }
                    KandayPreferencesDialog.this.dispose();
                }
            }
        );
        // Cancel{^̐
        JButton cancelButton = new JButton(
            aPreferences.getPreferencesDialogCancelbuttonText()
        );
        // Cancel{^ꂽA_CAOj
        cancelButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent ev) {
                    KandayPreferencesDialog.this.dispose();
                }
            });
        
        contentPane.add(foregroundLabel);
        contentPane.add(foregroundField);
        contentPane.add(foregroundChangeButton);
        contentPane.add(backgroundLabel);
        contentPane.add(backgroundField);
        contentPane.add(backgroundChangeButton);
        contentPane.add(applyButton);
        contentPane.add(cancelButton);

        layout.putConstraint(SpringLayout.WEST, foregroundLabel, 10, 
                              SpringLayout.WEST, contentPane);
        layout.putConstraint(SpringLayout.NORTH, foregroundLabel, 25,
                              SpringLayout.NORTH, contentPane);
        layout.putConstraint(SpringLayout.WEST, foregroundField, 10,
                              SpringLayout.EAST, foregroundLabel);
        layout.putConstraint(SpringLayout.NORTH, foregroundField, 25,
                              SpringLayout.NORTH, contentPane);
        layout.putConstraint(SpringLayout.WEST, foregroundChangeButton, 10,
                              SpringLayout.EAST, foregroundField);
        layout.putConstraint(SpringLayout.NORTH, foregroundChangeButton, 25,
                              SpringLayout.NORTH, contentPane);

        layout.putConstraint(SpringLayout.WEST, backgroundLabel, 10, 
                              SpringLayout.WEST, contentPane);
        layout.putConstraint(SpringLayout.NORTH, backgroundLabel, 20,
                              SpringLayout.SOUTH, foregroundLabel);
        layout.putConstraint(SpringLayout.WEST, backgroundField, 10,
                              SpringLayout.EAST, foregroundLabel);
        layout.putConstraint(SpringLayout.NORTH, backgroundField, 20,
                              SpringLayout.SOUTH, foregroundLabel);
        layout.putConstraint(SpringLayout.WEST, backgroundChangeButton, 10,
                              SpringLayout.EAST, foregroundField);
        layout.putConstraint(SpringLayout.NORTH, backgroundChangeButton, 20,
                              SpringLayout.SOUTH, foregroundLabel);

        layout.putConstraint(SpringLayout.WEST, applyButton, 10,
                             SpringLayout.EAST, backgroundLabel);
        layout.putConstraint(SpringLayout.SOUTH, applyButton, -10,
                             SpringLayout.SOUTH, contentPane);
        layout.putConstraint(SpringLayout.WEST, cancelButton, 25,
                             SpringLayout.EAST, applyButton);
        layout.putConstraint(SpringLayout.SOUTH, cancelButton, -10,
                             SpringLayout.SOUTH, contentPane);

        // SpringLayout̏ꍇApack()ł͑傫܂Ȃ
        setSize(320, 200);

        setResizable(false);
        setLocationRelativeTo(anOwner);
        logger.exiting(MYCLASS, "KandayPreferencesDialog");
    }

    private Color foregroundColor;
    private Color backgroundColor;

    private static final String MYCLASS =
        KandayPreferencesDialog.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);

}
